<id>
Patch # 2 for File Attachment V3.0h for SP1.3.x
</id>

<version>
1.1
</version>

<mod info>
fixed issues:
 - missing USERNAME and SUBJECT fields in "attachments.txt" file (2 parameters added in "do_attach()" function calls: $subject,$name)
 - remove selection box with attach_options during message modification, if it has no attachment
 - no entry in "attachments.txt" after message gets modifyed with new attachment
 - problems with proper update of "attachments.txt" while moving thread (thanks, Eddy! :-)
new features:
 - rename attachment (with file_name verification)
 - keep selected option in preview mode

INSTALLATION:
------------------
make sure that Ron's File Attachment mod V3.0h for SP1.3.x  was installed!

- Uninstall file_attachment_B3.0h_patch1.mod if it was installed

- Apply this patch by BoardMod

- Apply LanguagePack patch (important!) by BoardMod

- Upload (in ASCII mode!) the following updated files to your web server ./Sources directory:

 Subs.pl
 ModifyMessage.pl
 MoveThread.pl
 Post.pl

- Upload (in ASCII mode!) the updated Language file to your web server YaBB main directory

</mod info>

<author>
TheSkier, vikmars@yahoo.com
</author>

<homepage>
http://sopka.sakhalin.su
</homepage>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
sub do_attach {
	my($dowhat,$att,$old_att,$att_thread,$reply)= @_;
	if($dowhat eq "" || $att eq ""){ return 0; }
	if($dowhat eq "add" && ($att_thread eq "" || $reply eq "")){ return 0; }
	if($dowhat eq "swap" && $old_att eq ""){ return 0; }
	if ($dowhat ne "flush") {
		fopen(AML, "$vardir/attachments.txt");
		my @attachments = <AML>;
		fclose(AML);
		fopen(AML, ">$vardir/attachments.txt");
		foreach (@attachments) {
			chomp $_;
			my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);
			if($amfn ne $att && $amfn ne $old_att) {
				print AML qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
			} 
		}
		if($dowhat eq "add" && $action eq "post2") {
			print AML qq~$att_thread|$reply|$subject|$name|$currentboard|$filesizekb|$date|$att\n~;
		} elsif(($dowhat eq "add" || $dowhat eq "swap") && $action eq "modify2") {
			print AML qq~$att_thread|$reply|$subject|$musername|$currentboard|$filesizekb|$date|$att\n~;
		} elsif($dowhat eq "remove") {
			if (-e("$upload_dir/$att")) {
				unlink("$upload_dir/$att");
			}
		}
		if (-e("$upload_dir/$old_att")) {
			unlink("$upload_dir/$old_att");
		}
		fclose(AML);
	}
	elsif ($dowhat eq "flush" && $att eq "all") {
		opendir (AMD,$upload_dir) || &fatal_error("$fatxt{'19'} $upload_dir!");
			while ($files = readdir(AMD)) {
				if ($files ne "." && $files ne "..") {
					$killfile = "$upload_dir/$files";
					unlink($killfile);
				}
			}
		closedir(AMD);
		fopen(AML, ">$vardir/attachments.txt");
		fclose(AML);
	}
}
</search for>

<replace>
sub do_attach {
	my($dowhat,$att,$old_att,$att_thread,$reply,$subject,$name)= @_;
	if($dowhat eq "" || $att eq ""){ return 0; }
	if($dowhat eq "add" && ($att_thread eq "" || $reply eq "")){ return 0; }
#	if($dowhat eq "swap" && $old_att eq ""){ return 0; }	###(VM)::: NO_RETURN!
	if ($dowhat ne "flush") {
		fopen(AML, "$vardir/attachments.txt");
		my @attachments = <AML>;
		fclose(AML);
		fopen(AML, ">$vardir/attachments.txt");
		foreach (@attachments) {
			chomp $_;
			my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);
			if($amfn ne $att && $amfn ne $old_att) {
				print AML qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
			} 
				elsif (($dowhat eq "rename") && ($amfn eq $old_att)) { $am_buf = $_; }	###(VM)::: KEEP_ENTRY_WITH_OLD_FA
		}
		if(($dowhat eq "add" && $action eq "post2") || ($dowhat eq "add" || $dowhat eq "swap")) {
			print AML qq~$att_thread|$reply|$subject|$name|$currentboard|$filesizekb|$date|$att\n~;
			} elsif ($dowhat eq "rename") {	###(VM)::: RENAME_FILE
				my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$am_buf);
				if (rename("$upload_dir/$old_att","$upload_dir/$att")) {
					print AML qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$att\n~;
					fclose(AML); return(1);
				}
				else {return(-1);}	###/(VM)
			} elsif($dowhat eq "remove") {
			if (-e("$upload_dir/$att")) {
				unlink("$upload_dir/$att");
			}
		}
		if (-e("$upload_dir/$old_att") && ($old_att ne "") && ($dowhat ne "rename")) {
			unlink("$upload_dir/$old_att");	###(VM)::: check modes before removing
		}
		fclose(AML);
	}
	elsif ($dowhat eq "flush" && $att eq "all") {
		opendir (AMD,$upload_dir) || &fatal_error("$fatxt{'19'} $upload_dir!");
			while ($files = readdir(AMD)) {
				if ($files ne "." && $files ne "..") {
					$killfile = "$upload_dir/$files";
					unlink($killfile);
				}
			}
		closedir(AMD);
		fopen(AML, ">$vardir/attachments.txt");
		fclose(AML);
	}
}

###
###(VM): check if file_name valid
###
sub check_fname {
	my ($filename) = @_;

	($filename eq "")   and &write_error("$fatxt{'20a'}$fatxt{'20b'}");	### empty

	($filename =~ m,^([A-Za-z0-9\-_.]*)$,) ?
		($filename = $1) :
		(&write_error("$fatxt{'20a'}$fatxt{'20d'}"));	### ASCII only

	($filename =~ m,\.\.,)   and &write_error("$fatxt{'20a'}$fatxt{'20d'}");	### no double ..
	($filename =~ m,^\.,)    and &write_error("$fatxt{'20a'}$fatxt{'20d'}");	### no leading .
	(length($filename) > 30) and &write_error("$fatxt{'20a'}$fatxt{'20c'}");	### too long

	$filename =~ s/.+\\([^\\]+)$|.+\/([^\/]+)$/$1/;	### ???

	if ($checkext == 0) { $match = 1; } else {
	foreach $ext (@ext){
		chomp ($ext);
			if (grep /$ext$/i,$filename){$match=1; last;}
		}
	}
	if ($match) {
		return($filename);
	} else {
		&write_error("$fatxt{'20'} @ext ($filename)"); 
	}
}
###/(VM)

</replace>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
			&do_attach("swap",$fixfile,$mfn,$threadid,$treplies);
</search for>

<replace>
			&do_attach("swap",$fixfile,$mfn,$threadid,$treplies,$subject,$username);
</replace>

<search for>
		} elsif ($FORM{'w_file'} eq "attachdel" && -e("$upload_dir/$mfn")) {
			$is_attached = "";
			&do_attach("remove",$mfn);
</search for>

<add after>
		} elsif ($FORM{'w_file'} eq "attachren") {	###(VM)::: RENAME_ATTACH
			$is_attached = $mfn; $new_attname = $FORM{'new_attname'};
			if ($new_attname ne $mfn) {
				$new_attname = check_fname($new_attname);
				$new_attname = check_existence($upload_dir,$new_attname);
				&do_attach("rename",$new_attname,$mfn,$threadid,$treplies,$subject,$username) || &fatal_error("$fatxt{'6e'}: '$mfn' to '$new_attname'");	### NEED_TO_CHECK_RETURN!!
				$is_attached = "$new_attname";
			}	###/(VM)
</add after>

<edit file>
Sources/Post.pl
</edit file>

<search for>
##########################################
## Spikecity's File Attachment Mod V3.0 ##
##########################################
if ($allowattach == 1 && ($action eq 'post' || $action eq 'post2' || $action eq 'modify' || $action eq 'modify2') && (($allowguestattach == 0 && $username ne 'Guest') || $allowguestattach == 1)) {
$yymain .= qq~
<tr>
	<td valign="top"><b>$fatxt{'6'}</b></td>
	<td><input type="file" name="file" size="50" />~;
if ($action ne 'modify') {
	$yymain .= qq~<input type="hidden" name="w_file" value="attachnew" />~;
}
$yymain .= qq~
	</td>
</tr>
<tr>
	<td align="right"></td>
	<td><font size="1">$filetype_info<br />$filesize_info</font></td>
</tr>
~;
if ($action eq 'modify' && (-e "$upload_dir/$isatt")) {
	if($isatt ne ""){
		$oldattcheck = qq~selected="selected"~;
		$newattcheck = qq~~;
		$atistxt = qq~$fatxt{'40'}: <a href="$http_dir/$isatt">$isatt</a>~;
	} else {
		$newattcheck = qq~selected="selected"~;
		$oldattcheck = qq~~;
		$atistxt = "";
	}
$yymain .= qq~
<tr>
	<td valign="top"></td>
	<td><font size="1">
	<select name="w_file" size="1">
	<option value="attachdel">$fatxt{'6c'}</option>
	<option value="attachnew" $newattcheck>$fatxt{'6b'}</option>
	<option value="attachold" $oldattcheck>$fatxt{'6a'}</option>
	</select>&nbsp;$atistxt</font></td>
</tr>~;
}
if( ($is_preview == 1) && $FORM{'file'} ) {
$yymain .= qq~
<tr>
	<td align="right"></td>
	<td><font size="1">$fatxt{'7'}</font></td>
</tr>
~;
}
}
##########################################
##/Spikecity's File Attachment Mod V3.0 ##
##########################################
</search for>

<replace>
##########################################
## Spikecity's File Attachment Mod V3.0 ##
## (VM) + rename_attachment             ##
##########################################
if ($allowattach == 1 && ($action eq 'post' || $action eq 'post2' || $action eq 'modify' || $action eq 'modify2') && (($allowguestattach == 0 && $username ne 'Guest') || $allowguestattach == 1)) {
$yymain .= qq~
<tr>
	<td valign="top"><b>$fatxt{'6'}</b></td>
	<td><input type="file" name="file" size="50" />~;
$yymain .= qq~
	</td>
</tr>
<tr>
	<td align="right"></td>
</tr>
~;
if ($action eq 'modify' || $action eq 'modify2') {
#
if($is_preview == 1) {	###(VM)::: IN_PREVIEW!
	$isatt = $old_attname = $FORM{'old_attname'};
	$new_attname = $FORM{'new_attname'};
	$w_file=$FORM{'w_file'};
	$delattcheck = $newattcheck = $oldattcheck = $renattcheck = qq~~;

	if ($w_file eq "attachdel" ) {
		$delattcheck = qq~selected="selected"~; }
	elsif ($w_file eq "attachnew" ) {
		$newattcheck = qq~selected="selected"~; }
	elsif ($w_file eq "attachold" ) {
		$oldattcheck = qq~selected="selected"~; }
	elsif ($w_file eq "attachren" ) {
		$renattcheck = qq~selected="selected"~; }
	} else {$old_attname = $new_attname = $isatt;}

if($isatt ne ""){
	if (!$is_preview)	{
		$oldattcheck = qq~selected="selected"~;
		$newattcheck = qq~~;
	}
$atistxt = qq~$fatxt{'40'}: <a href="$http_dir/$isatt">$isatt</a>~;
$yymain .= qq~
<tr>
	<td valign="top"></td>
	<td><font size="1">
<script language ="JavaScript">
<!--
// ###(VM)::: HIGLIGHT_FILE_NAME
function selChange(seln,x_num,x_name) {
selNum = seln.w_file.selectedIndex;
Isel = seln.w_file.options[selNum].text;
seln.new_attname.value = x_name;
if (selNum == x_num) {
	seln.new_attname.focus();
	seln.new_attname.select();
	}
else {seln.new_attname.value = "";}
}
//-->
</script>
	<select name="w_file" size="1" onChange="selChange(this.form,3,'$new_attname')">
	<option value="attachdel">$fatxt{'6c'}</option>
	<option value="attachnew" $newattcheck>$fatxt{'6b'}</option>
	<option value="attachold" $oldattcheck>$fatxt{'6a'}</option>
	<option value="attachren" $renattcheck>$fatxt{'6d'}</option>
	</select>&nbsp;<input name="old_attname" type="hidden" value="$old_attname"><input name="new_attname" type="text" value="$new_attname" size="40"><input type="button" value="$txt{'278'}" onClick="javascript:this.form.new_attname.value='$old_attname'; this.form.new_attname.select()"><BR>$atistxt &nbsp;</font></td>
</tr>~;
	} else {	###(VM)::: NEW_ATTACHNENT, JUST_BROWSE!
		$yymain .= qq~<input type="hidden" name="w_file" value="attachnew">~;
	}
} else {	###(VM)::: NEW_ATTACHNENT, JUST_BROWSE! ###CHK!! USED_TWICE_BUT_WORKS!
		$yymain .= qq~<input type="hidden" name="w_file" value="attachnew">~;
	}
if( ($is_preview == 1) && $FORM{'file'} ) {
$yymain .= qq~
<tr>
	<td align="right"></td>
	<td><font size="1">$fatxt{'7'}</font></td>
</tr>
~;
}
}
##########################################
##/Spikecity's File Attachment Mod V3.0 ##
##########################################
</replace>

<search for>
			&do_attach("add",$fixfile,"",$newthreadid,"0");
</search for>

<replace>
			&do_attach("add",$fixfile,"",$newthreadid,"0",$subject,$username);
</replace>

<search for>
			&do_attach("add",$fixfile,"",$mnum,$mreplies);
</search for>

<replace>
			&do_attach("add",$fixfile,"",$mnum,$mreplies,$subject,$username);
</replace>

<edit file>
Sources/MoveThread.pl
</edit file>

<search for>
	if ($movedthread[12] ne "") {
		#fix attachment info
		fopen(AMP, "$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
		my @attachinfo = <AMP>;
		fclose(AMP);
		foreach (@attachinfo) {
			chomp $_;
			my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);
			if ($amfn eq $movedthread[13]) { 
				$_ = qq~$newthreadid|$amreplies|$amthreadsub|$amposter|$toboard|$amkb|$amdate|$amfn\n~;
				last;
			}
		}
		fopen(AMP, ">$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
		print AMP @attachinfo;
		fclose(AMP);

		#remove attachment from old post
		$movedthread[12] = "";
		$movedthread[13] = "";
	}
</search for>

<replace>
	###(VM)###################################
	## File Attachment Mod V3.0 (Eddy's fix)##
	##########################################
	  #fix attachment info
	  fopen(AMP, "$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
	  my @attachinfo = <AMP>; 
	  my $attachchg = 0;
	  fclose(AMP);
	  foreach (@attachinfo) {
		    my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);			 
		    if ($amthreadid eq $thread) { 
				$_ = qq~$newthreadid|$amreplies|$amthreadsub|$amposter|$toboard|$amkb|$amdate |$amfn~;
				$attachchg = 1;
		    }
	  }	 
	  if ($attachchg) {
		# only rewrite if it actually changed
		fopen(AMP, ">$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
		print AMP @attachinfo;
		fclose(AMP);
	  }	 

	  #remove attachment from old post
	  $movedthread[12] = "";
	  $movedthread[13] = "";
	###(VM)###################################
	## /File Attachment Mod V3.0 (Eddy's fix)#
	##########################################
</replace>
